<?
	### Written by Evgeny Stepanischev.
	### http://bolk.exler.ru
	### se@e-kazan.ru
	### BOLK_CPI_XBM class version 1.00. 13.07.2002

	class BOLK_CPI_XBM
	{
		var $fp;
		var $error;
		var $width;
		var $height;
		var $chars;
		var $pos;
		var $errmsg;

		function BOLK_CPI_XBM ($file = false, $cpnum = 1, $fontnum = 1)
		{
			$this->error  = 0;
			$this->errmsg = '';

			if ($file === false) return;

			$this->fp = @fopen ($file, 'rb');
			if (!$this->fp) return $this->_end(1);

			$sign = fread ($this->fp, 8);
			if ($sign == "\xFFFONT   ") $add_offset = 0; else
			if ($sign == "\xFFFONT.NT") $add_offset = 25; else
			return $this->_end(2);

			fseek ($this->fp, 15, SEEK_CUR);
   			$secnum = implode ('', unpack('S', fread ($this->fp, 2)));

			if ($cpnum > $secnum) return $this->_end(3);

			for ($i = 0; $i<$cpnum-1; $i++)
			{
				fseek ($this->fp, 2, SEEK_CUR);
				$next = implode ('', unpack ('L', fread ($this->fp, 4)));

				fseek ($this->fp, $next + $add_offset, SEEK_SET);
			}

			fseek ($this->fp, 6, SEEK_CUR);
			$devtype = implode ('', unpack ('S', fread ($this->fp, 2)));
			if ($devtype <> 1) return $this->_end(4);

			fseek ($this->fp, 22, SEEK_CUR);
			$no_of_fonts = implode ('', unpack ('S', fread ($this->fp, 2)));
			fseek ($this->fp, 2, SEEK_CUR);

			if ($no_of_fonts < $fontnum) return $this->_end(5);

			for ($size = $i = 0; $i < $fontnum; $i++)
			{
					fseek ($this->fp, $size, SEEK_CUR);
					$this->height  = ord(fread($this->fp, 1));
					$this->width = ord(fread($this->fp, 1));

					fseek ($this->fp, 2, SEEK_CUR);
					$this->chars = implode ('', unpack ('S', fread ($this->fp, 2)));

					$size = $this->chars * $this->height * ceil($this->width/8); // skip font body
			};

			$this->pos = ftell ($this->fp);
		}


		function printstr($str, $effect = false)
		{
			if ($this->error) return;

			$parts = array();
			$size  = $this->height * ($nw = ceil($this->width/8));

			for ($j = 0; $j<$size; $j++)
			for ($i = 0; $i<strlen($str); $i++)
			{
				fseek ($this->fp, $this->pos + ord($str[$i]) * $size + $j, SEEK_SET);
				$parts[] = $a = $this->_re(fread($this->fp, 1));
			};

			$parts = $this->_transform ($parts, $effect, $size, $nw, $height);

			header ("Content-type: image/x-xbitmap");
			echo
			"#define t_width ", ($nw << 3) * strlen($str) ,"\n",
			"#define t_height $height\n",
			"static unsigned char t_bits[] = {\n",
			join (', ', $parts).'}';
		}

		function Close()
		{
			if ($this->fp) fclose ($this->fp);
			$this->fp = false;
		}

		function AvailEffects()
		{
			return array ('speccy1', 'speccy2', 'blinders', 'invert', 'bold', 'snow', 'italic', 'strike', 'liner',
			'shake1', 'shake2', 'shake3', 'nonword', 'ripples', 'high', 'belt');
		}

		// private methods

		function _end($code)
		{
			$msgs = array ('',
			'Font file not found.',
			'Unknown font file format.',
			'Font code page section not found.',
			'Invalid font was selected.',
			'Font section not found.',
			);

			$this->errmsg = $msgs[$code];
			$this->Close();

			return $this->error = $code;
		}

		function _re ($char)
		{
			return ($val = ord($char)) ? $this->_bitreverse($val) : $val;
		}

		function _transform($parts, $effect = false, $size, $nw, &$height)
		{
			$num_of_chars = count($parts) / $size;
			$height = $this->height;

			if (!empty ($effect))
			{
				$effects = explode (',', $effect);
				for ($j = 0; $j<count($effects); $j++)
				{
					$out = array ();
					for ($i = 0; $i<count($parts); $i++)
					{
						$o = floor($i / ($nw * $num_of_chars));

						switch ($effects[$j])
						{
							case 'high':	 $out[] = $parts[$i];
											 if (!(($i + 1) % ($nw * $num_of_chars)))
											 for ($k = $num_of_chars - 1; $k>=0; $k--) $out[] = $parts[$i - $k];
											 break;

							case 'belt':	 $out[] = $parts[$i];
											 if (!(($i + 1) % ($nw * $num_of_chars)))
											 for ($k = 0; $k<$num_of_chars; $k++) $out[] = 0;
											 break;

							case 'speccy1':  $out[] = ($size >> 1) == $o ? $parts[$i] | ($parts[$i] >> 2) : $parts[$i]; break;
							case 'speccy2':  $out[] = ($size >> 1) < $o  ? $parts[$i] | ($parts[$i] >> 2) : $parts[$i]; break;
							case 'blinders': $out[] = $parts[$i] & 170; break;
							case 'invert':   $out[] = $parts[$i] ^ 255; break;
							case 'bold':     $out[] = $parts[$i] | $parts[$i] >> 1; break;
							case 'snow':	 $out[] = $parts[$i] | 1 << mt_rand(0, 7); break;
							case 'italic':	 $out[] = ($parts[$i] << ($o >> 2)); break;
							case 'strike':	 $out[] = $o == ($height >> 1) ? 255 : $parts[$i]; break;
							case 'liner':	 $out[] = $o == ($height >> 1) ? 0 : $parts[$i]; break;
							case 'shake1':	 $out[] = ($parts[$i] & 1) ? $parts[$i] >> 1 : $parts[$i]; break;
							case 'shake2':	 $out[] = ($parts[$i] & 1) ? $parts[$i] : $parts[$i] >> 1; break;
							case 'shake3':	 $out[] = ($parts[$i] & 1) ? $parts[$i] : $parts[$i] << 1; break;
							case 'nonword':	 if ($height >> 1 == $o && $parts[$i]) $out[] = 255; else $out[] = $parts[$i]; break;
							case 'ripples':	 $out[] = mt_rand(0,1) > 0.5 ? $parts[$i] << 1 : $parts[$i] ; break;

							default: $out[] = $parts[$i];
						}
					}

					$parts  = $out;
					$height = count($parts) / $num_of_chars * $nw;
				}
			}

			for ($i = 0; $i<count($parts); $i++) $parts[$i] = '0x'.dechex($parts[$i]);


			return $parts;
		}

		function _bitreverse($num)
		{
			for ($ret = $i = 0; $i<8 && $num; $i++)
			{
				$ret <<= 1;
				$ret |= $num & 1;
				$num >>= 1;
			}

			return $ret << 8-$i;
		}
	}
?>